2047
Comment: formatting and grammar fixes
|
5810
little fix in needle
|
Deletions are marked like this. | Additions are marked like this. |
Line 1: | Line 1: |
[[Anchor(faq35)]] == How can I handle command-line arguments to my script easily? == |
<<Anchor(faq35)>> == How can I handle command-line arguments (options) to my script easily? == |
Line 6: | Line 6: |
while [[ $1 == -* ]]; do case "$1" in -h|--help) show_help; exit 0;; -v) verbose=1; shift;; -f) output_file=$2; shift 2;; esac done # Now all of the remaining arguments are the filenames which followed # the optional switches. You can process those with "for i" or "$@". |
# Bash while [[ $1 == -* ]]; do case "$1" in -h|--help|-\?) show_help; exit 0;; -v|--verbose) verbose=1; shift;; -f) if (($# > 1)); then output_file=$2; shift 2 else printf "%s\n" "-f requires an argument" exit 1 fi ;; --) shift; break;; -*) echo "invalid option: $1"; show_help; exit 1;; esac done }}} Now all of the remaining arguments are the filenames which followed the optional switches. You can process those with `for i` or `"$@"`. A POSIX version of that same code: {{{ # POSIX while true; do case "$1" in -h|--help|-\?) show_help; exit 0;; -v|--verbose) verbose=1; shift;; -f) if [ $# -gt 1 ]; then output_file=$2; shift 2 else printf "%s\n" "-f requires an argument" exit 1 fi ;; --) shift; break;; -*) echo "invalid option: $1"; show_help; exit 1;; *) break;; esac done |
Line 17: | Line 44: |
For more complex/generalized cases, or if you want things like "-xvf" to be handled as three separate flags, you can use getopts. ('''NEVER use getopt(1)!''') Here is a simplistic getopts example: |
For more complex/generalized cases, or if you want things like "-xvf" to be handled as three separate flags, or if you want to handle [[http://www.gnu.org/software/libtool/manual/libc/Argument-Syntax.html|GNU-style long options]], you need a different approach. '''Never use getopt(1).''' `getopt` cannot handle empty arguments strings, or arguments with embedded whitespace. Please forget that it ever existed. The POSIX shell (and others) offer `getopts` which is safe to use. Here is a simplistic `getopts` example: |
Line 22: | Line 51: |
x=1 # Avoids an error if we get no options at all. while getopts "abcf:g:h:" opt; do case "$opt" in a) echo "You said a";; b) echo "You said b";; c) echo "You said c";; f) echo "You said f, with argument $OPTARG";; g) echo "You said g, with argument $OPTARG";; h) echo "You said h, with argument $OPTARG";; esac x=$OPTIND done shift $((x-1)) echo "Left overs: $@" |
# POSIX x=1 # Avoids an error if we get no options at all. while getopts "abcf:g:h:" opt; do case "$opt" in a) echo "You said a";; b) echo "You said b";; c) echo "You said c";; f) echo "You said f, with argument $OPTARG";; g) echo "You said g, with argument $OPTARG";; h) echo "You said h, with argument $OPTARG";; esac x=$OPTIND done shift $(($x-1)) echo "Left overs: $@" |
Line 38: | Line 68: |
There is still the disadvantage that options are coded in at least 2, probably 3 places - in the call to `getopts`, in the case statement that processes them and presumably in the help message that you are going to get around to writing one of these days. This is a classic opportunity for errors to creep in as the code is written and maintained - often not discovered till much, much later. | |
Line 39: | Line 70: |
If your prefer to check options with IFs then: | Another approach is to check options with `if` statements "on demand". A function like this one may be useful: |
Line 42: | Line 73: |
function HaveOpt { needle=$1 |
# Bash HaveOpt() { local needle=$1 |
Line 47: | Line 79: |
--) return 1; # stop now, since -- by convention is end of option arguments | --) return 1;; # by convention, -- is end of options |
Line 52: | Line 84: |
return 1; | return 1 |
Line 54: | Line 86: |
if HaveOpt --quick "$@"; then echo "Option quick is set"; fi | |
Line 55: | Line 88: |
and it will work if script is run as: | |
Line 56: | Line 90: |
may be useful. Use it like: | * YES: ./script --quick * YES: ./script -other --quick but will stop on first argument with no "-" in front (or on --): * NO: ./script -bar foo --quick * NO: ./script -bar -- --quick Of course, this approach (iterating over the argument list every time you want to check for one) is far less efficient than just iterating once and setting flag variables. But it does offer a consolidation of the option-handling code into a single place (or two places if you count the help message). [[http://bhepple.freeshell.org/oddmuse/wiki.cgi/process-getopt|bhepple]] suggests the use of [[http://sourceforge.net/projects/process-getopt/|process-getopt]] (GPL licensed) and offers this example code: |
Line 58: | Line 101: |
HaveOpt --quick "$@" && echo "Option quick is set" | PROG=$(basename $0) VERSION='1.2' USAGE="A tiny example using process-getopt(1)" # call process-getopt functions to define some options: source process-getopt SLOT="" SLOT_func() { [ "${1:-""}" ] && SLOT="yes"; } # callback for SLOT option add_opt SLOT "boolean option" s "" slot TOKEN="" TOKEN_func() { [ "${1:-""}" ] && TOKEN="$2"; } # callback for TOKEN option add_opt TOKEN "this option takes a value" t n token number add_std_opts # define the standard options --help etc: TEMP=$(call_getopt "$@") || exit 1 eval set -- "$TEMP" # just as with getopt(1) # remove the options from the command line process_opts "$@" || shift "$?" echo "SLOT=$SLOT" echo "TOKEN=$TOKEN" echo "args=$@" |
Line 60: | Line 128: |
Here, all information about each option is defined in one place making for much easier authoring and maintenance. A lot of the dirty work is handled automatically and standards are obeyed as in getopt(1) - because it calls getopt for you. . ''Actually, what the author forgot to say was that it's actually using `getopts` semantics, rather than `getopt`. I ran this test:'' {{{ wooledg@wooledg:~/process-getopt-1.6$ set -- one 'rm -rf /' 'foo;bar' "'" wooledg@wooledg:~/process-getopt-1.6$ call_getopt "$@" -- 'rm -rf /' 'foo;bar' ''\''' }}} . ''It appears to be intelligent enough to handle null options, whitespace-containing options, and single-quote-containing options in a manner that makes the [[BashFAQ/048|eval]] not blow up in your face. But this is not an endorsement of the process-getopt software overall; I don't know it well enough. -GreyCat |
|
Line 61: | Line 137: |
and it will work if script is run as: *YES: ./script --quick *YES: ./script -other --quick but will stop on first no minus argument (or --) *NO: ./script -bar foo --quick *NO: ./script -bar -- --quick |
It's written and tested on Linux where getopt(1) supports long options. For portability, it tests the local getopt(1) at runtime and if it finds an non-GNU one (ie one that does not return 4 for {{{getopt --test}}}) it only processes short options. It does not use the bash builtin getopts(1) command. -[[http://bhepple.freeshell.org/oddmuse/wiki.cgi/process-getopt|bhepple]] |
Line 68: | Line 139: |
Of course, this approach (iterating over the argument list every time you want to check for one) is far less efficient than just iterating once and setting flag variables. | ---- CategoryShell |
How can I handle command-line arguments (options) to my script easily?
Well, that depends a great deal on what you want to do with them. Here's a general template that might help for the simple cases:
# Bash while [[ $1 == -* ]]; do case "$1" in -h|--help|-\?) show_help; exit 0;; -v|--verbose) verbose=1; shift;; -f) if (($# > 1)); then output_file=$2; shift 2 else printf "%s\n" "-f requires an argument" exit 1 fi ;; --) shift; break;; -*) echo "invalid option: $1"; show_help; exit 1;; esac done
Now all of the remaining arguments are the filenames which followed the optional switches. You can process those with for i or "$@".
A POSIX version of that same code:
# POSIX while true; do case "$1" in -h|--help|-\?) show_help; exit 0;; -v|--verbose) verbose=1; shift;; -f) if [ $# -gt 1 ]; then output_file=$2; shift 2 else printf "%s\n" "-f requires an argument" exit 1 fi ;; --) shift; break;; -*) echo "invalid option: $1"; show_help; exit 1;; *) break;; esac done
For more complex/generalized cases, or if you want things like "-xvf" to be handled as three separate flags, or if you want to handle GNU-style long options, you need a different approach.
Never use getopt(1). getopt cannot handle empty arguments strings, or arguments with embedded whitespace. Please forget that it ever existed.
The POSIX shell (and others) offer getopts which is safe to use. Here is a simplistic getopts example:
# POSIX x=1 # Avoids an error if we get no options at all. while getopts "abcf:g:h:" opt; do case "$opt" in a) echo "You said a";; b) echo "You said b";; c) echo "You said c";; f) echo "You said f, with argument $OPTARG";; g) echo "You said g, with argument $OPTARG";; h) echo "You said h, with argument $OPTARG";; esac x=$OPTIND done shift $(($x-1)) echo "Left overs: $@"
There is still the disadvantage that options are coded in at least 2, probably 3 places - in the call to getopts, in the case statement that processes them and presumably in the help message that you are going to get around to writing one of these days. This is a classic opportunity for errors to creep in as the code is written and maintained - often not discovered till much, much later.
Another approach is to check options with if statements "on demand". A function like this one may be useful:
# Bash HaveOpt() { local needle=$1 shift while [[ $1 == -* ]]; do case "$1" in --) return 1;; # by convention, -- is end of options $needle) return 0;; esac shift done return 1 } if HaveOpt --quick "$@"; then echo "Option quick is set"; fi
and it will work if script is run as:
- YES: ./script --quick
- YES: ./script -other --quick
but will stop on first argument with no "-" in front (or on --):
- NO: ./script -bar foo --quick
- NO: ./script -bar -- --quick
Of course, this approach (iterating over the argument list every time you want to check for one) is far less efficient than just iterating once and setting flag variables. But it does offer a consolidation of the option-handling code into a single place (or two places if you count the help message).
bhepple suggests the use of process-getopt (GPL licensed) and offers this example code:
PROG=$(basename $0) VERSION='1.2' USAGE="A tiny example using process-getopt(1)" # call process-getopt functions to define some options: source process-getopt SLOT="" SLOT_func() { [ "${1:-""}" ] && SLOT="yes"; } # callback for SLOT option add_opt SLOT "boolean option" s "" slot TOKEN="" TOKEN_func() { [ "${1:-""}" ] && TOKEN="$2"; } # callback for TOKEN option add_opt TOKEN "this option takes a value" t n token number add_std_opts # define the standard options --help etc: TEMP=$(call_getopt "$@") || exit 1 eval set -- "$TEMP" # just as with getopt(1) # remove the options from the command line process_opts "$@" || shift "$?" echo "SLOT=$SLOT" echo "TOKEN=$TOKEN" echo "args=$@"
Here, all information about each option is defined in one place making for much easier authoring and maintenance. A lot of the dirty work is handled automatically and standards are obeyed as in getopt(1) - because it calls getopt for you.
Actually, what the author forgot to say was that it's actually using getopts semantics, rather than getopt. I ran this test:
wooledg@wooledg:~/process-getopt-1.6$ set -- one 'rm -rf /' 'foo;bar' "'" wooledg@wooledg:~/process-getopt-1.6$ call_getopt "$@" -- 'rm -rf /' 'foo;bar' ''\'''
It appears to be intelligent enough to handle null options, whitespace-containing options, and single-quote-containing options in a manner that makes the eval not blow up in your face. But this is not an endorsement of the process-getopt software overall; I don't know it well enough. -GreyCat
It's written and tested on Linux where getopt(1) supports long options. For portability, it tests the local getopt(1) at runtime and if it finds an non-GNU one (ie one that does not return 4 for getopt --test) it only processes short options. It does not use the bash builtin getopts(1) command. -bhepple